/* This makes my SCSI disk image work with RPCemu

 First, prepend 512 bytes of zeros to the SCSI disk image, then run this code
 to fixup the image

 hfiennes at gmail.com 20110306
*/

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
unsigned char buf[512];
int a,chk=0;
FILE *f;

f=fopen("hd4.hdf","rb+");
fseek(f,0xe00,SEEK_SET);
fread(buf,1,512,f);

/* Generate known-good hardware-dependent area */
for(a=0x1a0;a<=0x1bf;a++) buf[a]=0;
buf[0x1bb]=0x1;

/* Calculate checksum and store */
for(a=0;a<511;a++) chk=(chk&0xff)+(chk>>8)+buf[a];
buf[511]=chk&0xff;

/* Re-write */
fseek(f,0xe00,SEEK_SET);
fwrite(buf,1,512,f);

fclose(f);
}
